/* Native-dependent definitions for FreeBSD on MIPS, for GDB.
   Copyright 2001 Free Software Foundation, Inc.

This file is part of GDB.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef NM_FREEBSD_H
#define NM_FREEBSD_H

#ifdef HAVE_PT_GETDBREGS
#ifdef MIPS_USE_HW_WATCHPOINT

extern int mips_insert_watchpoint(CORE_ADDR addr, int len, int type);
extern int mips_remove_watchpoint(CORE_ADDR addr, int len, int type);
extern CORE_ADDR mips_stopped_data_address();

#define TARGET_CAN_USE_HARDWARE_WATCHPOINT(type, cnt, ot) 1

#define TARGET_REGION_OK_FOR_HW_WATCHPOINT(addr, len) 1


#define target_insert_watchpoint(addr, len, type) \
  mips_insert_watchpoint (addr, len, type)

#define target_remove_watchpoint(addr, len, type) \
  mips_remove_watchpoint (addr, len, type)

/* the step is handled by kernel ptrace PT_STEP */
#define SOFTWARE_SINGLE_STEP_P() (0)

#define HAVE_NONSTEPPABLE_WATCHPOINT 1

#define STOPPED_BY_WATCHPOINT(W) (mips_stopped_data_address () != 0)

#define target_stopped_data_address(target, x) mips_stopped_data_address()

#endif /* MIPS_USE_HW_WATCHPOINT */
#endif /* HAVE_PT_GETDBREGS */

#define FETCH_INFERIOR_REGISTERS

#define SVR4_SHARED_LIBS

/* Be shared lib aware */
#include "solib.h"

#define PTRACE_ARG3_TYPE char*

/* Override child_pid_to_exec_file in 'inftarg.c'.  */
#define CHILD_PID_TO_EXEC_FILE

/* We can attach and detach.  */
#define ATTACH_DETACH

/*
 * for MIPS/XLR BTLB (BigTLB):
 * one usage of BTLB is by setting the BTLB_FLAG environment variable,
 * to be able to start a BTLB application from within gdb,
 * we can use the "set environment BTLB_FLAG ..." command,
 * but for this to work, we cannot start the child with a shell, otherwise,
 * the kernel will think we want to start the shell with BTLB and 
 * fail the exec.
 */
#ifdef GDB_START_CHILD_DIRECTLY
#define STARTUP_WITH_SHELL 0
#define START_INFERIOR_TRAPS_EXPECTED	1
#endif

#endif /* NM_FREEBSD_H */
